/*
Stratix3_3sl150_dev_brd_Nios2Standard.v
This is a top level wrapper file that instanciates the
nios2 sopc builder system
flash interface fixed March 3, 2010
*/

module stratixIII_3sl150_dev_niosII_standard(
               // global signals:
                clkin_50,
                clkin_125,
                user_resetn,

               // the_flash_tristate_bridge_avalon_slave
                fsm_a,
                fsm_d,
                flash_oen,
                flash_cen,
                flash_wen,
                flash_advn,
                flash_resetn,
                //altmemddr signals
                ddr2_deva_dq,
                ddr2_deva_dqs_p,               
                ddr2_deva_a,
                ddr2_deva_ba,
                ddr2_deva_casn,
                ddr2_deva_cke,
                ddr2_deva_ck_n,
                ddr2_deva_ck_p,
                ddr2_deva_csn,
                ddr2_deva_dm,
                ddr2_deva_rasn,
                ddr2_deva_wen,
                ddr2_deva_odt,

                //altmemddr_1 signals
                ddr2_devb_dq,
                ddr2_devb_dqs_p,               
                ddr2_devb_a,
                ddr2_devb_ba,
                ddr2_devb_casn,
                ddr2_devb_cke,
                ddr2_devb_ck_n,
                ddr2_devb_ck_p,
                ddr2_devb_csn,
                ddr2_devb_dm,
                ddr2_devb_rasn,
                ddr2_devb_wen,
                ddr2_devb_odt,

               // the_lcd
                lcd_wen,
                lcd_data,
                lcd_csn,
                lcd_d_cn,

               // the quad seven segment display
                seven_seg_sel,
                seven_seg_a,
                seven_seg_b,
                seven_seg_c,
                seven_seg_d,
                seven_seg_e,
                seven_seg_f,
                seven_seg_g,
                seven_seg_dp,
                seven_seg_minus,

               // the_button_pio
                user_pb,

               // the_led_pio
                user_led,

               // Graphics LCD pio
               oled_bs1,
               oled_csn,
               oled_d_cn,
               oled_data,
               oled_e_rdn,
               oled_rstn,
               oled_sern,
               oled_wen,
               
               // Ethernet
               enet_resetn,
               enet_tx_d,
               enet_tx_clk,
               enet_tx_en,
               enet_gtx_clk,
               enet_rx_d,
               enet_rx_clk,
               enet_rx_col,
               enet_rx_crs,
               enet_rx_dv,
               enet_mdio,
               enet_mdc,
               enet_resetn
);

  // Ethernet
  output           enet_resetn;
  output  [ 3: 0]  enet_tx_d;
  output           enet_tx_clk;
  output           enet_tx_en;
  output           enet_gtx_clk;
  input   [ 3: 0]  enet_rx_d;
  input            enet_rx_clk;
  input            enet_rx_col;
  input	           enet_rx_crs;
  input            enet_rx_dv;
  inout            enet_mdio;
  output		   enet_mdc;

  // OLED screen
  output           oled_bs1;
  output           oled_csn;
  output           oled_d_cn;
  inout   [ 7: 0]  oled_data;
  output           oled_e_rdn;
  output           oled_rstn;
  output           oled_sern;
  output           oled_wen;
  
  // Seven segment display
  output  [4:  1]  seven_seg_sel;
  output           seven_seg_a;
  output           seven_seg_b;
  output           seven_seg_c;
  output           seven_seg_d;
  output           seven_seg_e;
  output           seven_seg_f;
  output           seven_seg_g;
  output           seven_seg_dp;
  output           seven_seg_minus;
  
  // LCD screen
  output           lcd_wen;
  inout   [  7: 0] lcd_data;
  output           lcd_csn;
  output           lcd_d_cn;
  output  [ 24: 0] fsm_a;
  inout   [ 31: 0] fsm_d;
  output  [ 12: 0] ddr2_deva_a;
  output  [  1: 0] ddr2_deva_ba;
  output           ddr2_deva_casn;
  output           ddr2_deva_cke;
  output           ddr2_deva_odt;
  inout            ddr2_deva_ck_n;
  inout            ddr2_deva_ck_p;
  output           ddr2_deva_csn;
  output           ddr2_deva_dm;
  inout   [  7: 0] ddr2_deva_dq;
  inout            ddr2_deva_dqs_p;
  output           ddr2_deva_rasn;
  output           ddr2_deva_wen;
  output  [ 12: 0] ddr2_devb_a;
  output  [  1: 0] ddr2_devb_ba;
  output           ddr2_devb_casn;
  output           ddr2_devb_cke;
  output           ddr2_devb_odt;
  inout            ddr2_devb_ck_n;
  inout            ddr2_devb_ck_p;
  output           ddr2_devb_csn;
  output           ddr2_devb_dm;
  inout   [  7: 0] ddr2_devb_dq;
  inout            ddr2_devb_dqs_p;
  output           ddr2_devb_rasn;
  output           ddr2_devb_wen;
  output  [  7: 0] user_led;
  output           flash_oen;
  output           flash_cen;
  output           flash_wen;
  output           flash_resetn;
  output           flash_advn;
  input            clkin_50;
  input            clkin_125;
  input   [  3: 0] user_pb;
  input            user_resetn;
  
  wire    [  3: 0] oled_control;
  wire    [ 24: 0] fsm_a_alignment; // only 24:0
  wire             flash_select_n;
  wire             flash_1_select_n;
  wire    [ 12: 0] seven_seg_data;
  
  wire             enet_mdc;
  wire             enet_mdio;
  wire             mdio_in;
  wire             mdio_out;
  wire             mdio_oen;
  wire             enet_gtx_clk;
  wire             enet_resetn;
  wire             enet_tx_clk_mac;
  wire             enet_tx_clk_phy;
  wire             enet_rx_clk_270deg;


  assign oled_bs1	      = 0;
  assign oled_sern	      = 1;
  assign oled_rstn        = user_resetn;
  assign oled_csn         = oled_control[0];
  assign oled_d_cn        = oled_control[1]; //Address line 0=instruction 1=data
  assign oled_e_rdn       = oled_control[2];
  assign oled_wen         = oled_control[3];
  assign seven_seg_a      = seven_seg_data[0];
  assign seven_seg_b      = seven_seg_data[1];
  assign seven_seg_c      = seven_seg_data[2];
  assign seven_seg_d      = seven_seg_data[3];
  assign seven_seg_e      = seven_seg_data[4];
  assign seven_seg_f      = seven_seg_data[5];
  assign seven_seg_g      = seven_seg_data[6];
  assign seven_seg_dp     = seven_seg_data[7];
  assign seven_seg_minus  = seven_seg_data[8];
  assign seven_seg_sel[1] = seven_seg_data[9];
  assign seven_seg_sel[2] = seven_seg_data[10];
  assign seven_seg_sel[3] = seven_seg_data[11];
  assign seven_seg_sel[4] = seven_seg_data[12];
														// only 25 bits come from the flash the way it is configured.  so the upper address
														// bit is from the chip select
														// the other way to have done this is to remove the second flash and make the first 
														// twice as big. 
  assign fsm_a[24:0] = {!flash_1_select_n,fsm_a_alignment[24:1]}; //The address A0 on the flash ssram buss is dropped because the flash is 16bit and the ssram is 32bit
  assign flash_resetn = user_resetn;
  assign flash_advn = 1'b0;
  assign flash_cen = flash_select_n & flash_1_select_n;
  
  // MDIO Tristate
  assign mdio_in = enet_mdio;
  
  assign enet_mdio = (mdio_oen == 1'b0)? mdio_out : 1'bz;
  
  ddr_o phy_ckgen
  (
	.datain_h(1'b1),
	.datain_l(1'b0),
	.outclock(enet_tx_clk_phy),
	.dataout(enet_gtx_clk)
  );
  
  // Ethernet RX PLL
  enet_rx_clk_pll enet_rx_clk_pll
  (
		.inclk0(enet_rx_clk),
		.c0(enet_rx_clk_270deg)
  );
  
  // Ethernet TX PLL
  enet_tx_clk_pll enet_tx_clk_pll
  (
		.inclk0(clkin_50),
		.c0(enet_tx_clk_mac),
		.c1(enet_tx_clk_phy)
  );
    

	stratixIII_3sl150_dev_niosII_standard_sopc this_stratixIII_3sl150_dev_niosII_standard_sopc
	(
	    .LCD_E_from_the_lcd_display(lcd_csn),
        .LCD_RS_from_the_lcd_display(lcd_d_cn),
        .LCD_RW_from_the_lcd_display(lcd_wen),
        .LCD_data_to_and_from_the_lcd_display(lcd_data),
		.mem_addr_from_the_altmemddr(ddr2_deva_a),
		.mem_ba_from_the_altmemddr(ddr2_deva_ba),
		.mem_cas_n_from_the_altmemddr(ddr2_deva_casn),
		.mem_cke_from_the_altmemddr(ddr2_deva_cke),
		.mem_clk_n_to_and_from_the_altmemddr(ddr2_deva_ck_n),
		.mem_clk_to_and_from_the_altmemddr(ddr2_deva_ck_p),
		.mem_cs_n_from_the_altmemddr(ddr2_deva_csn),
		.mem_dm_from_the_altmemddr(ddr2_deva_dm),
		.mem_dq_to_and_from_the_altmemddr(ddr2_deva_dq),
		.mem_dqs_to_and_from_the_altmemddr(ddr2_deva_dqs_p),
		.mem_ras_n_from_the_altmemddr(ddr2_deva_rasn),
		.mem_we_n_from_the_altmemddr(ddr2_deva_wen),
		.mem_odt_from_the_altmemddr(ddr2_deva_odt),
	    .global_reset_n_to_the_altmemddr(user_resetn),
		.mem_addr_from_the_altmemddr_1(ddr2_devb_a),
		.mem_ba_from_the_altmemddr_1(ddr2_devb_ba),
		.mem_cas_n_from_the_altmemddr_1(ddr2_devb_casn),
		.mem_cke_from_the_altmemddr_1(ddr2_devb_cke),
		.mem_clk_n_to_and_from_the_altmemddr_1(ddr2_devb_ck_n),
		.mem_clk_to_and_from_the_altmemddr_1(ddr2_devb_ck_p),
		.mem_cs_n_from_the_altmemddr_1(ddr2_devb_csn),
		.mem_dm_from_the_altmemddr_1(ddr2_devb_dm),
		.mem_dq_to_and_from_the_altmemddr_1(ddr2_devb_dq),
		.mem_dqs_to_and_from_the_altmemddr_1(ddr2_devb_dqs_p),
		.mem_ras_n_from_the_altmemddr_1(ddr2_devb_rasn),
		.mem_we_n_from_the_altmemddr_1(ddr2_devb_wen),
		.mem_odt_from_the_altmemddr_1(ddr2_devb_odt),
	    .global_reset_n_to_the_altmemddr_1(user_resetn),
		.out_port_from_the_led_pio(user_led),
		.flash_tristate_bridge_readn(flash_oen),
		.flash_tristate_bridge_address(fsm_a_alignment), // this is only 24:0
		.flash_tristate_bridge_data(fsm_d),
		.select_n_to_the_ext_flash(flash_select_n),
		.select_n_to_the_ext_flash_1(flash_1_select_n),
		.flash_tristate_bridge_writen(flash_wen),
		.osc_clk(clkin_50),
		.osc_clk_1(clkin_125),
		.in_port_to_the_button_pio(user_pb),
        .out_port_from_the_quad_seven_seg_pio(seven_seg_data),
		.reset_n(user_resetn),
	
	    // the_tse_mac
        .ena_10_from_the_tse_mac(1'b1),
        .eth_mode_from_the_tse_mac(),
        .mdc_from_the_tse_mac(enet_mdc),
        .mdio_in_to_the_tse_mac(mdio_in),
        .mdio_oen_from_the_tse_mac(mdio_oen),
        .mdio_out_from_the_tse_mac(mdio_out),
        .rgmii_in_to_the_tse_mac(enet_rx_d),
        .rgmii_out_from_the_tse_mac(enet_tx_d),
        .rx_clk_to_the_tse_mac(enet_rx_clk_270deg),
        .rx_control_to_the_tse_mac(enet_rx_dv),
        .set_1000_to_the_tse_mac(1'b1),
        .set_10_to_the_tse_mac(1'b0),
        .tx_clk_to_the_tse_mac(enet_tx_clk_mac),
        .tx_control_from_the_tse_mac(enet_tx_en)
        
	);


endmodule

